import pygame, random, Globals,pygame.mixer


class Manager(object):
    def __init__(self, sounds, image,shadow):
        self.sounds = sounds
        self.image = image
        self.shadow = shadow
        self.shadow.set_alpha(155)
        self.last = 0
        self.delay = 5000
        self.channel = pygame.mixer.Channel(0)
        self.channel.play(self.sounds[0][0])
        self.channel.stop()
        self.channel.set_volume(0.3)
        self.bc = pygame.mixer.Channel(1)
        self.bc.play(self.sounds[5][0])
        self.bc.set_volume(0.5)
        self.l = 0
        self.frame = 0
        self.cnt = -1
    def update(self,rx, ry, h, dt, state):
        if state == 0:
            self.delay -= dt*1000
            if self.delay <= 0:
                if ry > 400:
                    if not self.channel.get_busy():
                        nl = self.l
                        while self.l == nl:
                            nl = random.randrange(0,len(self.sounds[1]))
                        
                        self.channel.play(self.sounds[1][nl])
                        self.delay = random.randrange(700,1000)
                        self.l = nl
                elif ry > 200:
                    if not self.channel.get_busy():
                        nl = self.l
                        while self.l == nl:
                            nl = random.randrange(0,len(self.sounds[1]))
                        
                        self.channel.play(self.sounds[2][nl])
                        self.delay = random.randrange(1000,2000)
                        self.l = nl
                else:
                    if not self.channel.get_busy():
                        nl = self.l
                        while self.l == nl:
                            nl = random.randrange(0,len(self.sounds[1]))
                        
                        self.channel.play(self.sounds[3][nl])
                        self.delay = random.randrange(700,1000)
                        self.l = nl
            self.frame += 13*dt
                
            if int(self.frame) >= 4:
                self.frame = 0

            if not self.bc.get_busy():
                self.bc.play(self.sounds[5][0])
        elif state == 1:
            #caught
            self.bc.fadeout(1000)
            if self.cnt == -1:
               self.cnt = 0
        elif state == 2:
            #caught
            self.bc.fadeout(1000)
            if self.cnt == -1:
                pass
               #self.channel.play(self.sounds[4][random.randrange(1,5)])
               #self.cnt = 0
               #self.channel.set_volume(0.3)
                    
            
            
            


    def draw(self):
        pygame.display.get_surface().blit(self.shadow, (0,600-90))
        ix,iy = 0,96*int(self.frame)
        r = (ix,iy, 256,96)
        pygame.display.get_surface().blit(self.image, (0,600-90), r)        
        
