import pygame, random,Globals

W = 32
H = 32

MOVEX = 200
MOVEF = Globals.SCROLLSPEED/6
MOVEB = Globals.SCROLLSPEED-(Globals.SCROLLSPEED/10)

class Player(object):
    def __init__(self, x, y, image, shadow):
        self.x = float(x)
        self.y = float(y)
        self.z = 0.0
        self.dx = 0
        self.dy = 0
        self.image = image
        self.shadow = shadow
        self.shadow.set_alpha(100)
        self.frame = 0.0
        self.vert = 0.0
        self.jstart = 0
        self.jumping = False
        self.dir = 0
        self.state = 0
        self.bk = 20
    def update(self,delta, c, h):

        if self.state == 0:
            if self.dy < 0:
                self.y += self.dy*MOVEF*delta
                self.dir = 1
            elif self.dy > 0:
                self.y += self.dy*MOVEB*delta
                self.dir = -1
            else:
                self.dir = 0
            col = c((self.x-5,self.y-16+h,10,32),(), self.jumping,h)
            if col[0]:
                if col[1] == 4:
                    if self.dir == 1:
                        if self.y > ((col[3]-h)+16):
                            self.y = ((col[3]-h)+16)+33
                    elif self.dir == -1:
                        if self.y > ((col[3]-h)+16):
                            self.y = ((col[3]-h)+16)+33
                    elif self.dir == 0:
                        if self.y > ((col[3]-h)+16):
                            self.y = ((col[3]-h)+16)+32
                if col[1] == 2:
                    if self.dir == 1:
                        if self.y-16 > ((col[3]-h)+16):
                            self.y = ((col[3]-h)+16)+32
                    elif self.dir == -1:
                        if self.y < ((col[3]-h)-16):
                            self.y = ((col[3]-h)-16)-32
                    elif self.dir == 0:
                        pass
                        
                    self.y += (delta * Globals.SCROLLSPEED)
                elif col[1] == 1 or (col[1] == 3):
                    self.y += (col[2]*delta*(Globals.SCROLLSPEED/10))

            self.x += self.dx*MOVEX*delta
            col = c((self.x-4,self.y-16+h,10,32),(), self.jumping,h)
            if col[0]:
                if col[1] == 4 or col[1] == 2:
                    self.x -= ((self.dx*MOVEX*delta))
                if col[1] == 3 or col[1] == 1:
                    self.x -= (self.dx*MOVEX*delta)-(self.dx*(MOVEX/col[2])*delta)

            if self.x < 16:
                self.x = 16
            if self.x > 256-16:
                self.x = 256-16
            if self.y < 16:
                self.y = 16
            if self.y > 600-16:
                self.y = 600-16

            if self.dir == 0:
                self.frame += 10*delta
            if self.dir == -1:
                self.frame -= 5*delta
            if self.dir == 1:
                self.frame += 13*delta
                
            if self.frame >= 4:
                self.frame = 0
            if self.frame < 0:
                self.frame = 4



            if self.jumping:      
                self.vert -= 4000 * delta
                self.z += self.vert * delta
                
            if self.z < 0:
                self.z = 0
                if self.vert < 0:
                    self.jumping = False
        if self.state == 1:
            #caught
            self.y += Globals.SCROLLSPEED*delta

            if self.jumping:      
                self.vert -= 4000 * delta
                self.z += self.vert * delta
                
            if self.z < 0:
                self.z = 0
                if self.vert < 0:
                    self.jumping = False
            if self.bk <= 0:
                self.state = 0
        if self.state == 2:
            self.y -= Globals.SCROLLSPEED*delta
        if self.state == 3:
            self.y += Globals.SCROLLSPEED*delta
        
    def move(self,dx, dy):
        self.dx += dx
        self.dy += dy
    def jump(self):
        if not self.jumping and self.state == 0:
            self.vert = 800
            self.jumping = True
            self.frame = 0
        if self.state == 1:
            self.bk -= 1
    def draw(self):
        pygame.display.get_surface().blit(self.shadow, (int(self.x)-16, int(self.y)-16))

        if self.state == 0 or self.state == 2:
            if not self.jumping:
                ix,iy = 0,32*((int(self.frame)))
                r = (ix,iy, 32,32)
                pygame.display.get_surface().blit(self.image, (int(self.x)-16,int(self.y-(self.z/2))-16), r)
            else:
                ix,iy = 0,32*(5)
                r = (ix,iy, 32,32)
                pygame.display.get_surface().blit(self.image, (int(self.x)-16,int(self.y-(self.z/2))-16), r)        
        elif self.state == 1 or self.state == 3:
            ix,iy = 0,32*((int(6)))
            r = (ix,iy, 32,32)
            pygame.display.get_surface().blit(self.image, (int(self.x)-16,int(self.y-(self.z/2))-16), r)
            
