import pygame

class TileSystem(object):
    def __init__(self, filename, tilew, tileh, image):
        self.image = image
        self.tilew = tilew
        self.tileh = tileh
        self.filename = filename
        self.mw = -1
        self.mh = -1
        self.t = []
    def load(self):
        f = open(self.filename, "r")
        self.mw = int(f.readline().replace("\n",""))
        self.mh = int(f.readline().replace("\n",""))

        for line in f:
            if line != '\n':
                c, u = "-1","-1"
                n = int(line[0:line.find('-')])
                s = line[line.find('-')+1:len(line)].replace("\n","")
                c = s[0:s.find('-')]
                if c == '':
                    c = s[0:len(s)]
                else:
                    u = s[s.find('-')+1:len(s)]

                
                
                self.t.append((n, int(c), int(u)))


        f.close()

    def getColl(self,rect, ignore,air, h):
        x,y,z,w = 0,0,0,0
        r = pygame.Rect(rect)
        tx,ty = 0,0
        for t in self.t:
            if t[1] > 0:
                if ((ty*self.tileh) > h-32) and ((ty*self.tileh) < h+600):
                    if t[1] not in ignore:
                        r2 = pygame.Rect(tx*self.tilew,ty*self.tileh,self.tilew,self.tileh)
                        if t[1] == 4:
                            if r2.colliderect(r):
                                x = True
                                y = t[1]
                                z = t[2]
                                w = (ty*self.tileh)
                                return x,y,z,w
                        elif t[1] == 2:
                            if r2.colliderect(r):
                                if ((not air) and (r2.centery < r.centery+8)):
                                    x = True
                                    y = t[1]
                                    z = t[2]
                                    w = (ty*self.tileh)
                                    return x,y,z, w
                        elif t[1] == 1:
                            if r2.collidepoint(r.center):
                                x = True
                                y = t[1]
                                z = t[2]
                                w = (ty*self.tileh)
                                return x,y,z,w
                        elif t[1] == 3:
                            if not air:
                                if r2.collidepoint(r.center):
                                    x = True
                                    y = t[1]
                                    z = t[2]
                                    w = (ty*self.tileh)
                                    return x,y,z,w
                    
            tx+=1
            if tx >= self.mw:
                tx = 0
                ty += 1
            
        return False,-1,-1
            
    def draw(self, h):
        x, y = 0,0
        for i in self.t:
            ix,iy = 0,self.tileh*(i[0]-1)
            r = (ix,iy, self.tilew,self.tileh)
            if ((y*self.tileh) > h-32) and ((y*self.tileh) < h+600):
                pygame.display.get_surface().blit(self.image, (x*self.tilew,(y*self.tilew)-h), r)
            x+=1
            if x >= self.mw:
                x = 0
                y += 1
